/************************************************************************/
/*                        Potmot ALPS v0.1                              */
/*                      RC5 Remote Receiver                             */
/*                                                                      */
/*              Author: Peter Dannegger                                 */
/*                      danni@specs.de                                  */
/*                                                                      */
/************************************************************************/

#ifndef __RC5_H__
#define __RC5_H__

#define F_CPU 4000000UL               // Clock frequency

#define RC5TIME   1.778e-3            // 1.778msec
#define PULSE_MIN (unsigned char)(F_CPU / 512 * RC5TIME * 0.4 + 0.5)
#define PULSE_1_2 (unsigned char)(F_CPU / 512 * RC5TIME * 0.8 + 0.5)
#define PULSE_MAX (unsigned char)(F_CPU / 512 * RC5TIME * 1.2 + 0.5)

#define xRC5_IN   PINC
#define xRC5      PC0                 // IR input low active

struct RC5STRUCT {                    // Important: Declare RC5STRUCT variables as volatile !
  volatile unsigned char bit;         // bit value
  volatile unsigned char time;        // count bit time
  volatile unsigned int  tmp;         // shift bits in
  volatile unsigned int  data;        // store result
};

extern struct RC5STRUCT rc5;

void rc5_scheduler(void);


#endif /* __RC5_H__ */
